import type { IndexBufferDescriptor, InputState, VertexBufferDescriptor } from '@antv/g-plugin-device-renderer';
import { ResourceType } from '@antv/g-plugin-device-renderer';
import type { Device_GL } from './Device';
import type { InputLayout_GL } from './InputLayout';
import type { Program_GL } from './Program';
import { ResourceBase_GL } from './ResourceBase';
export declare class InputState_GL extends ResourceBase_GL implements InputState {
    type: ResourceType.InputState;
    vao: WebGLVertexArrayObject;
    indexBufferByteOffset: number | null;
    indexBufferType: GLenum | null;
    indexBufferCompByteSize: number | null;
    inputLayout: InputLayout_GL;
    vertexBuffers: (VertexBufferDescriptor | null)[];
    constructor({ id, device, inputLayout, vertexBuffers, indexBufferBinding, program, }: {
        id: number;
        device: Device_GL;
        inputLayout: InputLayout_GL;
        vertexBuffers: (VertexBufferDescriptor | null)[];
        indexBufferBinding: IndexBufferDescriptor | null;
        program: Program_GL;
    });
    destroy(): void;
}
//# sourceMappingURL=InputState.d.ts.map